#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>

#define MAX_MOSSE 1000000
#define T 2.

double RandDouble(double,double);
double Accettanza(double,double,double);
double Pot(double);

void ComputeMeanAndVariance(double[],int,double[]);

main(){
	
	double seed;
	
	int NMosse;
	int k,NAccept=0;
	double XOld, XNew;
	double VOld, VNew, VDiff,Accept;
	double Delta;
	
	double Posizioni[MAX_MOSSE], MeanAndVar[2];
	
	seed=time(0);
	srand48(seed);

	printf("Prototipo di Monte Carlo.... \n\n");

	do{
		printf("\n\nInserire il numero di mosse Monte Carlo\n\n");
		scanf("%d",&NMosse);
		if(NMosse<=0)printf("Il numero deve essere positivo");
		if(NMosse>=MAX_MOSSE)printf("Il numero deve essere minore di %d",MAX_MOSSE);
	}while(NMosse<=0 || NMosse>=MAX_MOSSE);
	
	
	do{
		printf("\n\nInserire il valore di Delta\n\n");
		scanf("%lf",&Delta);
		if(Delta<2.)printf("Troppo piccolo, deve essere almeno 2");
		if(Delta>6.)printf("Troppo grande, deve essere al massimo 6");
	}while(Delta<2. || Delta>6.);
	

	
	do{
		printf("\n\nInserire la posizione iniziale\n\n");
		scanf("%lf",&XOld);
		if(XOld<1.)printf("Troppo a sinistra, maggiore di 1 per favore");
		if(XOld>3.)printf("Troppo a destra: minore di 3 per favore");
	}while(XOld<1.|| XOld>3.);
	

	Posizioni[0]=XOld;
	VOld=Pot(XOld);	
	
	for(k=1;k<NMosse;k++){
	
		XNew=XOld+RandDouble(-Delta,Delta);
		VNew=Pot(XNew);
		VDiff=VNew-VOld;
		
		if(VNew<=VOld){
            NAccept++;
			XOld=XNew;
			VOld=VNew;
		}else{
		XNew=Accettanza(XOld,XNew,VDiff);
		}
		if(XOld!=XNew){
			NAccept++;
			XOld=XNew;
	        VOld=VNew;
		}
		
		Posizioni[k]=XOld;
	}	

	printf("\n\nL'accettanza vale %lf\n\n",(double)NAccept/NMosse);

	ComputeMeanAndVariance(Posizioni,NMosse,MeanAndVar);
	
	printf("\n\nLa posizione media e' %lf\n\n", MeanAndVar[0]);
	printf("\n\nLa varianza e' %lf\n\n", MeanAndVar[1]);
	
}


/* DEFINIZIONE DELLE FUNZIONI */


double Pot(double x){
	double potential;
	
	potential=0.5*(x-2.)*(x-2.);
	
	return potential;
}


double Accettanza(double xo,double xn,double dpot){
	double nu, Tdpot, PRatio;
	
	Tdpot=dpot/T;
	PRatio=exp(-Tdpot);
	nu=RandDouble(0.,1.);
	
	if(PRatio<nu)xn=xo;
	

	return xn;

}

double RandDouble(double Max, double Min){
	double random;
	
	random=(double)lrand48()/(RAND_MAX+1.)*(Max-Min)+Min;
	
	return random;
}

void ComputeMeanAndVariance(double vec[], int N, double res[]){
	int i;
	double temp=0.;
	res[0]=0.;
	
	for(i=0;i<N;i++){
		res[0]+=vec[i];
	}

	res[0]=res[0]/N;
	
	for(i=0;i<N;i++){
		temp+=(vec[i]-res[0])*(vec[i]-res[0]);
	}
	
	res[1]=sqrt(temp/(N-1.));
	
	return;

}